# upload

* 作者：quying
* 邮箱：qy9404@163.com
* 版本：**`0.2.0`**

## 介绍

基本上传组件


## 安装

`lm-*` 组件使用 `npm` 进行管理，命名空间统一为 `lm-`，请使用以下命令进行组件安装。

```
npm i lm-upload --save
```

- 如果你还没有安装 `npm`，可通过以下方式进行 [安装](https://nodejs.org/en/download/)。
- 安装cnpm `npm install -g cnpm --registry=https://registry.npm.taobao.org`




## 使用

### 样例文档

- 待开发

### 使用
最少配置参数为：
- 默认无显示，需要增加样式，或传入子元素
- 该子元素为点击触发上传区域

```
<Upload 
    accept="image/*" 
    beforeUpload={ this.beforeUpload }
    onStart={ this.onStart }
    onSuccess={ this.onSuccess }
>
    <div className="lm-upload">
        <div className="lm-upload-item">
            <label className="lm-upload-item-img"></label>
        </div>
    </div>
</Upload>

```
### 配置参数

| Prop | Type | Default | Description |
| ---- |:----:|:-------:| :----------:|
| **`name`** | `string` | `undefined` | 文件名 |
| **`accept`** | `string` | `undefined` | 接受的文件类型 |
| **`multiple`** | `string` | `bool` | 是否支持多选文件 |
| **`onInputChange`** | `function` | `undefined` | 文件选择后回调 (files) => boolean / Promise |
| **`beforeUpload`** | `function` | `undefined` | 上传前回调 (file, fileList) => boolean / Promise |
| **`customUpload`** | `function` | `undefined` | 自定义上传实现(传入xhr options) |
| **`disabled`** | `bool` | `undefined` | 是否禁用 |
| **`action`** | `string` | `undefined` | 上传的地址 |
| **`data`** | `object/function/promise` | `undefined` | 表单数据 |
| **`headers`** | `object` | `undefined` | xhr请求头 |
| **`onStart`** | `function` | `undefined` | 开始上传回调 |
| **`onProgress`** | `function` | `undefined` | 上传进度  onProgress(e, file) |
| **`onSuccess`** | `function` | `undefined` | 上传成功回调  onSuccess(ret, file, xhr) |
| **`withCredentials`** | `bool` | `undefined` | 允许跨域发送cookie |
| **`appUpload`** | `function` | `undefined` | 调用app上传 |




## 注意事项

- 组件注意事项



## 开发调试

进入项目目录后，使用 `node` 命令启动服务

```
npm run start
```

打包发布可通过 `node` 命令执行

```
npm run build
npm publish
```



## 相关资料

* [lm 组件开发规范](http://)



## Changelog

### 0.1.0
1. init

### 0.1.1
1. clear input value after upload

### 0.1.2
1. add onInputChange event
2. add style props

### 0.1.5
1. clear input value bug fix
2. async data bug fix

### 0.2.0
1. update react to version 16

---
